import java.awt.*;
import javax.swing.*;


import javax.swing.JFrame;

public class Simulate extends Thread{
	/**
	 * 
	 */
	private static int NBIDDERS = 10;
	private static int NRECIPIENTS = 10;
	private static final int NSUM = 10;
	private static final int MAXROUNDS = 4;
	private static final boolean debug = true;
	private static final boolean debugAuction = true;
	private static int round = 0;
	private static Agent [] bidders, recipients;
	
	private static float [] totalBoughtByBidder,
							totalSoldByBidder;
	private SimulateBoard sb;
	private boolean pauze = false;
//	private boolean halt = false;
	private boolean randomThresholds = false;
	private boolean makeRandomBid = false;
	private int pauzeMilliSeconds = 500;
	private int experiment = 1;
	
	public Simulate(SimulateBoard sb)
	{
		this.sb = sb;
		System.out.println(sb.myNumber);
	}
	
//	auction phase
	public  void auction(int waitTime)
	{
		//The information each bidder has collected will be auctioned
		for (int bidderInfo = 0; bidderInfo < NBIDDERS; bidderInfo++)
		{
			//get the information this agent has to offer for each recipient
			for (int r = 0; r < NRECIPIENTS; r++)
			{				
				//the info this agent has about this recipient
				int accLow = bidders[bidderInfo].acceptLow(recipients[r], false);
				int accHigh = bidders[bidderInfo].acceptHigh(recipients[r], false);
				
				if(debugAuction)
				{
					System.out.println("\nAuction info of bidder "
							+ bidderInfo + ", about recipient " 
							+ r + " : accLow: " + accLow 
							+ ", accHigh: " + accHigh);
				}
				
				float highestAuctionBid = 0;
				float secondHighestAuctionBid = 0;
				int idxOfWinner = -1;
				
				float [] bids = new float[NBIDDERS];;
				//Each bidder will make a bid for this specific information
				for (int bidderMakingOffer = 0; bidderMakingOffer < NBIDDERS; bidderMakingOffer++)
				{
					//store all bids of for this piece of information
					
					// this bidder will say what he offers for the information
					float bid = bidders[bidderMakingOffer].auctionBid(recipients[r], accLow, accHigh);
					bids[bidderMakingOffer] = bid;
					
					if (debugAuction)
						System.out.println("Agent " + bidderMakingOffer + " bids " + bid);
					
					if ( bid > highestAuctionBid)
					{
						secondHighestAuctionBid = highestAuctionBid;
						highestAuctionBid = bid;
						idxOfWinner = bidderMakingOffer;
					}
					else if (bid < highestAuctionBid && bid > secondHighestAuctionBid)
					{
						secondHighestAuctionBid = bid;
					}
				}
				
				if (debugAuction)
					System.out.println("Winner was agent " 
							+ idxOfWinner + " with bid " + highestAuctionBid);
				
				
				sb.showAuctionPrior(bidders, recipients, bids, bidderInfo, r, round);
				
				//if someone did bid on this information
				if (highestAuctionBid > 0)
				{
					//winner has to pay the second highest auction bid!
					bidders[idxOfWinner].pay(secondHighestAuctionBid);
					//and gets the information
					bidders[idxOfWinner].storeInformation(accLow, accHigh, r);
					
					//the total amount of money spend on buying is stored
					totalBoughtByBidder[idxOfWinner] += highestAuctionBid;
					//also the information being sold is stored
					totalSoldByBidder[bidderInfo] += highestAuctionBid;
				}
				sb.showAuctionPost(bidders, recipients, bids, bidderInfo, r, secondHighestAuctionBid, idxOfWinner, round);
				pauze();
			}
		}
	}
	
//	public void halt()
//	{
//		this.halt = true;
//	}
//	
//	public boolean halting()
//	{
//		return halt;
//	}
	
	public  void initialize(boolean randomThresholds)
	{
		round = 0;
		
		bidders = new Agent[NBIDDERS];
		recipients = new Agent[NRECIPIENTS];
		
		totalBoughtByBidder = new float[NBIDDERS];
		totalSoldByBidder = new float[NBIDDERS];
		
		//RandomThresholds
		if (randomThresholds)
		{
			for (int b = 0; b < NBIDDERS; b++)
			{
				//a bidder can offer anything from 0 to 10;
				int threshold = (int)(Math.random() * 11);
				bidders[b] = new Agent(b,  threshold, b, NRECIPIENTS, NSUM, MAXROUNDS, debug);
			}
			for (int r = 0; r < NRECIPIENTS; r++)
			{
				//a recipient can accept anything from 0 to 10
				int threshold = (int)(Math.random() * 11);
				recipients[r] = new Agent(r,  r, threshold, NBIDDERS, NSUM, MAXROUNDS, debug);
			}
		}
		else if (NBIDDERS <= 10 && NRECIPIENTS <= 10)
		{
			for (int b = 0; b < NBIDDERS; b++)
			{
				bidders[b] = new Agent(b,  b + 1, b, NRECIPIENTS, NSUM, MAXROUNDS, debug);
			}
			for (int r = 0; r < NRECIPIENTS; r++)
			{
				recipients[r] = new Agent(r,  r, r + 1, NBIDDERS, NSUM, MAXROUNDS, debug);
			}
		}
		else
			System.err.println("incorrect number of agents for non-random initialization");	
	}
	
	public void setPauze(int milliSeconds)
	{
		this.pauzeMilliSeconds = milliSeconds;
	}
	
	public void setNBidders(int bidders)
	{
		sb.setNBidders(bidders);
		this.NBIDDERS = bidders;
	}
	
	public void setNRecipients(int recipients)
	{
		sb.setNRecipients(recipients);
		this.NRECIPIENTS = recipients;
	}
	
	public void setRandomBid(boolean randomBid)
	{
		this.makeRandomBid = randomBid;
	}
	
	public void setRandomThresholds(boolean randomThresholds)
	{
		this.randomThresholds = randomThresholds;
	}
	
	public  void pauze()
	{
		if (pauze)
		{
			try 
			{
				Thread.sleep(Long.MAX_VALUE);
			}
			catch (InterruptedException e){}
		}
		else
		{
			try 
			{
				Thread.sleep(pauzeMilliSeconds);
			}
			catch (InterruptedException e){}
		}
	}
	
	public void setExperiment(int experiment)
	{
		this.experiment = experiment;
	}
	
//	public void runAgain()
//	{
//		switch (experiment){
//		case 0:
//			System.out.println("Please set experiment number");
//			break;
//		case 1:
//			initialize(randomThresholds);
//			doOfferRound("FixedBid", 1);
//			break;
//		case 2:
//			initialize(randomThresholds);
//			doOfferRound("OptimumBid", 1);
//			break;
//		case 3:
//			initialize(randomThresholds);
//			doOfferRound("OptimumBid", 1);
//			doOfferRound("OptimumBid", 1);
//			doOfferRound("OptimumBid", 1);
//			doOfferRound("OptimumBid", 1);
//			break;
//		case 4:
//			initialize(randomThresholds);
//			doOfferRound("FixedBid", 1);	
//			auction(1);
//			doOfferRound("OptimumBid", 2);
//			break;
//		}
//	}
	
	public void run()
	{
		switch (experiment){
		case 0:
			System.out.println("Please set experiment number");
			break;
		case 1:
			initialize(randomThresholds);
			doOfferRound("FixedBid", 1);
			break;
		case 2:
			initialize(randomThresholds);
			doOfferRound("OptimumBid", 1);
			break;
		case 3:
			initialize(randomThresholds);
			doOfferRound("OptimumBid", 1);
			doOfferRound("OptimumBid", 1);
			doOfferRound("OptimumBid", 1);
			doOfferRound("OptimumBid", 1);
			break;
		case 4:
			initialize(randomThresholds);
			doOfferRound("FixedBid", 1);
			try 
			{
				Thread.sleep(5000);
			}
			catch (InterruptedException e){}
			auction(1);
			try 
			{
				Thread.sleep(30000);
			}
			catch (InterruptedException e){}
			doOfferRound("OptimumBid", 2);
			break;
		}
	}
	
	public  void doOfferRound(String strategy, int waitTime) 
	{
		if (debug)
			System.out.println("\n------------NEW ROUND " + round + " ---------------\n");

		for (int b = 0; b < NBIDDERS; b++)
		{
			for (int r = 0; r < NRECIPIENTS; r++)
			{	
				sb.showTradePrior(bidders, recipients,b, r, strategy,round);
				bidders[b].setBiddingStrategy(strategy);
				int bid = bidders[b].determineBid(recipients[r], round);
				bidders[b].doBid(bid, recipients[r], round);
				bidders[b].printOffers(r, round);
				sb.showTradePost(bidders, recipients,b, r, bid, strategy,round);
		
				//recipients[r].printReceived();
				pauze();
			}
			if (debug)
				System.out.println("Score of bidder " + b + " = " + bidders[b].myScore());
		}
		pauze();
		round++;
	}
}